DECLARE SUB DosSleep ()
'* v1.0 Very Simple, Very Free, no warranty of any kind.
'*
'* As always, test anything before using it.
'*
'* This program demonstrates how to keep a DOS program, running in a
'* OS/2 Virtual Dos Machine, from hogging the cpu by simply forcing the
'* DOS machine to give up it's time slice. I found this to be much more
'* effective (and simple) than using IDLE_SECONDS and IDLE_SENSITIVITY
'* settings. We currently run 3 OS2 VDMs, each with a MS QuickBasic
'* program. We found the background apps always suffered when an input
'* intense DOS program was in the foreground. This simple change made
'* all the difference.
'*
'* You can simply add the DosSleep subroutine to your program and then
'* insert CALL DosSleep in routines that wait for kepboard input using
'* INKEY$ function, for example, the EditString() function.
'*
'* To run this from within QB Editor, you must use QB /L
'* When linking, be sure to specify QB as a library.
'*
'* Let me know if you find it useful or have suggestions.
'* Carl R. Staton

'********************************************************************
'*             Add following lines to your program                  *
'********************************************************************

' $INCLUDE: 'QB.BI'

   DEFINT A-Z                           ' use integers

   Yes = -1                             '
   No = 0                               '

   DIM SHARED INREGS(7), OUTREGS(7)     ' arrays used by INT86OLD function

   DosSleepCount% = 0                   ' counter
   DosSleepCountInterval% = 8           ' number of times to wait before
					'  actually giving up time slice.
					'  This just provides a simple
					'  tuning capability, I doubt you
					'  will need to change it.

'********************************************************************
'*             Add previous  lines to your program                  *
'********************************************************************

   CLS
   LOCATE 2, 1
   PRINT "Start up PULSE and press Enter"
   PRINT "You will see it indicates the system is extremely busy."

   SleepIndicator% = No                 ' turn OFF sleeping
   GOSUB GetAKey

   LOCATE 5, 1
   PRINT "Now look at PULSE and you will see it indicates the system"
   PRINT " is only a little busy."

   SleepIndicator% = Yes                ' turn ON  sleeping
   GOSUB GetAKey

   LOCATE 8, 1
   PRINT "Demo ended."

END

GetAKey:
  i$ = ""
  WHILE i$ <> CHR$(13)                  ' wait for Enter
    i$ = INKEY$
    IF SleepIndicator% = Yes THEN CALL DosSleep
    IF LEN(i$) = 1 THEN i% = ASC(i$)
    IF LEN(i$) = 2 THEN i% = ASC(RIGHT$(i$, 1))
    SELECT CASE i%
      CASE 0                            ' Nothing typed yet
      CASE 13                           ' if Enter, pass it thru
      CASE 48 TO 122                    ' if is a printable character,
	LOCATE 23, 1                    ' then show it
	PRINT "Last key pressed: "; i$; '
      CASE ELSE                         ' ignore everything else
       i$ = ""
    END SELECT
  WEND
  RETURN

SUB DosSleep

'*  Force virtual machine to give up control of cpu to OS/2 by issueing
'*  undocumented DOS interrupt &H2F with parameter &H1680 in AX register.
'*
'*  This routine requires:
'*    - QuickBasic QB.BI include file

    SHARED INREGS(), OUTREGS(), iRegax, iRegdx
    SHARED DosSleepCountInterval%, DosSleepCount%

    DosSleepCount% = DosSleepCount% + 1              ' increment counter
    IF DosSleepCount% > DosSleepCountInterval% THEN  ' interval reached ?
      INREGS(iRegax) = &H1680                        ' y, set register values
      CALL INT86OLD(&H2F, INREGS(), OUTREGS())       '    issue DOS interrupt
      DosSleepCount% = 0                             '    reset interval ctr
    END IF                                           '

END SUB

