' Rotate.bas by Matt E. Hart
'
' One alternate image of a star polygon is included.  Just RESTORE
' to CUBE or STAR in the line just below INIT:
'
SCREEN 9
REDIM acos!(0 TO 359)
REDIM asin!(0 TO 359)
CPi = 3.141592654# / 180
FOR i = 0 TO 359
    acos!(i) = COS(i * CPi)
    asin!(i) = SIN(i * CPi)
NEXT
GOSUB Init
DO
    GOSUB ShowIt
    a$ = INKEY$
    IF LEN(a$) = 0 THEN GOTO Skip
    KeyPress = ASC(RIGHT$(a$, 1))
    IF LEN(a$) = 2 THEN KeyPress = -KeyPress
    SELECT CASE KeyPress
        CASE 27: EXIT DO                        ' Escape
        CASE 45, 95                             ' -_
            IF S > 1 THEN S = 1
            S = S - .01
        CASE 43, 61                             ' +=
            IF S < 1 THEN S = 1
            S = S + .01
        CASE -72, 56                            ' Up arrow, 8
            XA = XA + 1: IF XA > 359 THEN XA = 0
        CASE -80, 50                            ' Dn
            XA = XA - 1: IF XA < 0 THEN XA = 359
        CASE -75, 52                            ' Left, 4
            ZA = ZA + 1: IF ZA > 359 THEN ZA = 0
        CASE -77, 54                            ' Right, 6
            ZA = ZA - 1: IF ZA < 0 THEN ZA = 359
        CASE 55                                 ' 7
            YA = YA + 1: IF YA > 359 THEN YA = 0
        CASE 57                                 ' 9
            YA = YA - 1: IF YA < 0 THEN YA = 359
        CASE 32: GOSUB Init                     ' Space (reset)
    END SELECT
Skip:
LOOP
SCREEN 0
END
Init:
    CLS
    RESTORE CUBE
    READ n
    REDIM x(1 TO n), y(1 TO n), z(1 TO n)
    REDIM xe(1 TO n), ye(1 TO n)
    FOR i = 1 TO n
        READ x(i), y(i), z(i)
    NEXT
    READ XF, YF, ZF
    READ XO, YO, ZO
    S = 1
    YA = 0: XA = 0: ZA = 0
RETURN
ShowIt:
    FOR i = 1 TO n
        IF x(i) <> -1 THEN  ' use -1 X coord to define a new plane
            GOSUB RotateX
            GOSUB RotateZ
            GOSUB RotateY
            SELECT CASE KeyPress
                CASE 45, 95, 43, 61 ' scaling
                    x(i) = x(i) * S + XF * (1 - S)    ' Scaling
                    y(i) = y(i) * S + YF * (1 - S)
                    z(i) = z(i) * S + ZF * (1 - S)
            END SELECT
        END IF
    NEXT
    KeyPress = 0
    Start = -1
    FOR i = 1 TO n
        IF x(i) <> -1 THEN
            IF x(i) <> xe(i) OR y(i) <> ye(i) THEN
                IF Start THEN
                    PSET (xe(i), ye(i)), 0
                    PSET (x(i), y(i)), 15
                    Start = 0
                ELSE
                    LINE (xe(i - 1), ye(i - 1))-(xe(i), ye(i)), 0
                    LINE (x(i - 1), y(i - 1))-(x(i), y(i)), 15
                END IF
            END IF
        ELSE
            Start = -1
        END IF
    NEXT
    FOR i = 1 TO n
        xe(i) = x(i)
        ye(i) = y(i)
    NEXT
RETURN
RotateZ:
    xs = x(i)       ' preserve x(i) for the y(i) calculation
    x(i) = XO + (x(i) - XO) * acos!(ZA) + (y(i) - YO) * asin!(ZA)
    y(i) = YO + (y(i) - YO) * acos!(ZA) - (xs - XO) * asin!(ZA)
RETURN
RotateY:
    xs = x(i)
    x(i) = XO + (x(i) - XO) * acos!(YA) - (z(i) - ZO) * asin!(YA)
    z(i) = ZO + (z(i) - ZO) * acos!(YA) + (xs - XO) * asin!(YA)
RETURN
RotateX:
    ys = y(i)
    y(i) = YO + (y(i) - YO) * acos!(XA) + (z(i) - ZO) * asin!(XA)
    z(i) = ZO + (z(i) - ZO) * acos!(XA) - (ys - YO) * asin!(XA)
RETURN
CUBE:
DATA 33
DATA 100,100,100
DATA 100,200,100
DATA 200,200,100
DATA 200,100,100
DATA 100,100,100
DATA -1,-1,-1

DATA 100,100,200
DATA 100,200,200
DATA 200,200,200
DATA 200,100,200
DATA 100,100,200
DATA -1,-1,-1

DATA 100,100,100
DATA 100,100,200
DATA -1,-1,-1

DATA 200,100,200
DATA 200,100,100
DATA -1,-1,-1

DATA 200,200,100
DATA 200,200,200
DATA -1,-1,-1
DATA 100,200,200
DATA 100,200,100
DATA -1,-1,-1

DATA 150,150,100
DATA -1,-1,-1

DATA 100,125,125
DATA -1,-1,-1

DATA 100,175,175
DATA -1,-1,-1

DATA 125,125,125
DATA 175,175,175
DATA -1,-1,-1

DATA 150,150,0
DATA 150,150,150

STAR:
DATA 6
DATA 100,200,100
DATA 150,100,100
DATA 200,200,100
DATA 100,150,100
DATA 200,150,100
DATA 100,200,100

DATA 150,150,0
DATA 150,150,100
