DECLARE SUB PlayWav (wavefile$)
DECLARE SUB ValidWavHeader (FILE$, LenHeader%, dataLen&, nChannels%, nSamplesPerSec&, nAvgBytesPerSec&, ok%)
DECLARE SUB WriteToDSP (v%)
DECLARE SUB PlayBack (buffer$, size%, freq&, BytesPerSec&, chans%, num%)
DECLARE SUB delay (tdelay!)
DECLARE FUNCTION GetBlasterAddr% ()
DECLARE FUNCTION SBreset% ()
COMMON SHARED BlasterAddr%, dma%, repeats%
CALL PlayWav(COMMAND$)

DEFINT A-Z
SUB delay (tdelay!)
time1! = TIMER
DO
LOOP WHILE (TIMER - time1! < tdelay!) OR (time1! > TIMER)
END SUB

FUNCTION GetBlasterAddr%
tmp% = 0: blast$ = UCASE$(ENVIRON$("BLASTER"))
IF LEN(blast$) THEN
  tmp% = INSTR(blast$, "A")
  tmp1$ = MID$(blast$, tmp% + 1, 3)
  tmp% = VAL("&H" + tmp1$)
  IF tmp% = 203 THEN tmp% = -1
  IF tmp% > 0 THEN
    tmp2% = INSTR(blast$, "D")
    dma% = VAL(MID$(blast$, tmp2% + 1))
    IF dma% < 0 OR dma% > 7 THEN tmp% = -2
  END IF
END IF
GetBlasterAddr% = tmp%
END FUNCTION

SUB PlayBack (buffer$, size%, freq&, BytesPerSec&, chans%, num%)
size% = size% - 1
segment& = VARSEG(buffer$)
offset& = SADD(buffer$)
IF segment& < 0 THEN segment& = segment& + 65536
IF offset& < 0 THEN offset& = offset& + 65536
baseaddr& = segment& * 16 + offset&
look1% = VARPTR(baseaddr&)
look2% = VARPTR(size%)
SELECT CASE dma%
   CASE 0
      dmapage% = &H87   '135 decimal
      dmaaddr% = 0
      dmalen% = 1
   CASE 1
      dmapage% = &H83   '131 decimal
      dmaaddr% = 2
      dmalen% = 3
   CASE 2
      dmapage% = &H81
      dmaaddr% = 4
      dmalen% = 5
   CASE 3
      dmapage% = &H82
      dmaaddr% = 6
      dmalen% = 7
   CASE 4
      dmapage% = &H8F
      dmaaddr% = &HC0
      dmalen% = &HC2
   CASE 5
      dmapage% = &H8B
      dmaaddr% = &HC4
      dmalen% = &HC6
   CASE 6
      dmapage% = &H89
      dmaaddr% = &HC8
      dmalen% = &HCA
   CASE 7
      dmapage% = &H8A
      dmaaddr% = &HCC
      dmalen% = &HCE
END SELECT
SELECT CASE dma%
   CASE 0 TO 3
      dmamask% = &HA
      dmamode% = &HB
      dmaclear% = &HC
      dmastatus% = &H8
   CASE 4 TO 7
      dmamask% = &HD4
      dmamode% = &HD6
      dmaclear% = &HD8
      dmastatus% = &HD0
END SELECT
SELECT CASE dma%
   CASE 0, 4
      dmaterminal% = 1
   CASE 1, 5
      dmaterminal% = 2
   CASE 2, 6
      dmaterminal% = 4
   CASE 3, 7
      dmaterminal% = 8
END SELECT
OUT dmamask%, dma% + 4
OUT dmaclear%, &H0
OUT dmamode%, 72 + dma%
OUT dmaaddr%, PEEK(look1%)
OUT dmaaddr%, PEEK(look1% + 1)
OUT dmapage%, PEEK(look1% + 2)
OUT dmalen%, PEEK(look2%)
OUT dmalen%, PEEK(look2% + 1)
OUT dmamask%, dma%
IF num% = 1 THEN  'only need to Write out time constant once
   timeconst% = 256 - 1000000 / (freq& * chans%)
   CALL WriteToDSP(&H40)
   CALL WriteToDSP(timeconst%)
   OUT BlasterAddr% + &H4, &H0
   OUT BlasterAddr% + &H4 + 1, 0
   OUT BlasterAddr% + &H4, &H22
   OUT BlasterAddr% + &H4 + 1, 255
   IF chans% = 2 THEN
      OUT BlasterAddr% + &H4, &HE
      OUT BlasterAddr% + &H4 + 1, 34
   END IF
END IF
IF BytesPerSec& > 22000 THEN
   CALL WriteToDSP(&H48)
ELSE
   CALL WriteToDSP(&H14)
END IF
CALL WriteToDSP(PEEK(look2%))
CALL WriteToDSP(PEEK(look2% + 1))
IF BytesPerSec& > 22000 THEN CALL WriteToDSP(&H91)
dummy% = INP(dmastatus%)
WAIT dmastatus%, dmaterminal%
dummy% = INP(BlasterAddr% + &HE)
END SUB

DEFSNG A-Z
SUB PlayWav (wavefile$)
repeats% = 1
BlasterAddr% = GetBlasterAddr%
SELECT CASE BlasterAddr%
  CASE -2
    PRINT "Bad DMA Channel specified!"
    END
  CASE -1
    PRINT "No Port Base Address Given!"
    END
  CASE 0
    PRINT "No BLASTER Environment Variable Set!"
    END
  CASE ELSE
END SELECT
IF NOT SBreset% THEN
  PRINT "SoundBlaster Card Would Not Reset!"
  END
END IF
sp% = INSTR(Spec$, " ")
IF sp% THEN
  wavefile$ = LEFT$(Spec$, sp% - 1)
  repeats% = VAL(RIGHT$(Spec$, LEN(Spec$) - sp%))
  IF repeats% = 0 THEN repeats% = 1
ELSE
  IF LEN(Spec$) THEN
    wavefile$ = Spec$
    repeats% = 1
  END IF
END IF
IF LEN(wavefile$) = 0 THEN
END IF
CALL ValidWavHeader(wavefile$, LenHeader%, WavLen&, Channels%, Sampling&, bytes&, ok%)
IF NOT ok% THEN
  PRINT "Bad Wave File Format"
  END
END IF
MaxBuffer% = 7053
CALL WriteToDSP(&HD1)
FOR repeat% = 1 TO repeats%
  filenum% = FREEFILE
  OPEN wavefile$ FOR BINARY AS filenum%
  num% = 0
  SEEK filenum%, LenHeader% + 1
  Remaining& = WavLen&
  DO
    IF INKEY$ = CHR$(27) THEN END
    num% = num% + 1
    IF Remaining& > MaxBuffer% THEN
      BufferLen% = MaxBuffer%
    ELSE
      BufferLen% = Remaining&
    END IF
    Remaining& = Remaining& - BufferLen%
    buffer$ = SPACE$(BufferLen%)
    GET filenum%, , buffer$
    CALL PlayBack(buffer$, BufferLen%, Sampling&, bytes&, Channels%, num%)
  LOOP WHILE Remaining& > 0
  OUT &H20, &H20
  CLOSE filenum%
NEXT repeat%
CALL WriteToDSP(&HD3)
END SUB

DEFINT A-Z
FUNCTION SBreset%
OUT BlasterAddr% + &H6, 1
delay .1
OUT BlasterAddr% + &H6, 0
time1! = TIMER: noreset% = 0
DO
  IF TIMER - time1! > 1! THEN noreset% = -1
LOOP UNTIL ((INP(BlasterAddr% + &HE) AND 128) = 128) OR noreset%
IF NOT noreset% THEN
  IF INP(BlasterAddr% + &HA) = &HAA THEN
    SBreset% = -1
  ELSE
    SBreset% = 0
  END IF
ELSE
  SBreset% = 0
END IF
END FUNCTION

SUB ValidWavHeader (FILE$, LenHeader%, dataLen&, nChannels%, nSamplesPerSec&, nAvgBytesPerSec&, ok%)
rID$ = SPACE$(4)
wID$ = SPACE$(4)
fID$ = SPACE$(4)
dat$ = SPACE$(4)
dummy$ = SPACE$(1)
filenum% = FREEFILE
OPEN FILE$ FOR BINARY AS filenum%
GET filenum%, , rID$
GET filenum%, , rLen&
GET filenum%, , wID$
GET filenum%, , fID$
GET filenum%, , fLen&
GET filenum%, , wFormatTag%
GET filenum%, , nChannels%
GET filenum%, , nSamplesPerSec&
GET filenum%, , nAvgBytesPerSec&
GET filenum%, , nBlockAlign%
GET filenum%, , FormatSpecific%
FOR i% = 1 TO fLen& - 16
  GET filenum%, , dummy$
NEXT i%
GET filenum%, , dat$
IF UCASE$(dat$) = "FACT" THEN
  GET filenum%, , dummy&
  GET filenum%, , dummy&
  GET filenum%, , dat$
END IF
GET filenum%, , dataLen&
LenHeader% = LOC(1)
CLOSE filenum%
IF UCASE$(rID$) = "RIFF" THEN
  IF UCASE$(wID$) = "WAVE" THEN
    IF UCASE$(dat$) = "DATA" THEN
      IF UCASE$(fID$) = "FMT " THEN
        IF FormatSpecific% = 8 THEN ok% = -1
      END IF
    END IF
  END IF
END IF
END SUB

SUB WriteToDSP (v%)
DO
LOOP UNTIL (INP(BlasterAddr% + &HC) AND 128) = 0
OUT BlasterAddr% + &HC, v%
END SUB

