DECLARE FUNCTION GetDelay% ()
DECLARE FUNCTION RandNum! (u%)
DECLARE SUB ReGenerate (Times%)
DECLARE SUB PlotStart (Times%)

TYPE PixelType
 XPos AS INTEGER
 Ypos AS INTEGER
 Dir AS INTEGER
 Xincr AS INTEGER
 yincr AS INTEGER
 Col AS INTEGER
END TYPE

TYPE Pixel
 x AS SINGLE
 y AS SINGLE
 height AS INTEGER
 gradient AS SINGLE
 vdir AS INTEGER
 hdir AS INTEGER
 Col AS INTEGER
END TYPE

TYPE StarType
 XPos AS DOUBLE
 Ypos AS DOUBLE
 Xincr AS DOUBLE
 yincr AS DOUBLE
 Total AS INTEGER
 Dir AS INTEGER
 Size AS INTEGER
 Active AS INTEGER
 Switcher AS INTEGER
END TYPE

SMax% = 35      ' # of stars in 3D star field

DIM Pixel(Max%) AS Pixel
DIM SHARED Stars(SMax%) AS StarType
DIM Points(NumPoints%) AS PixelType

'$DYNAMIC
DEFINT A-Z
RANDOMIZE TIMER

CLS
SCREEN 7


LoopAgain:
DO
 PCOPY 3, 2
 SCREEN , , 2, 0
   
    GOSUB StarWarp
   
 PCOPY 2, 0
 SCREEN , , 2, 0
 PCOPY 3, 2
 SCREEN , , 2, 0
 PCOPY 2, 0
 SCREEN , , 2, 0
LOOP
GOTO LoopAgain

NoBug:
       DEF SEG = 0
       Status% = PEEK(&H417)
       POKE &H417, (Status% XOR Send%)
RETURN

StarWarp:
 FOR Times% = 1 TO SMax%
   PSET (Stars(Times%).XPos, Stars(Times%).Ypos), 0
   Stars(Times%).Active = Stars(Times%).Active + 1
   SELECT CASE Stars(Times%).Dir
     CASE 1: Stars(Times%).XPos = Stars(Times%).XPos - Stars(Times%).Xincr
             Stars(Times%).Ypos = Stars(Times%).Ypos - Stars(Times%).yincr
     CASE 2: Stars(Times%).XPos = Stars(Times%).XPos + Stars(Times%).Xincr
             Stars(Times%).Ypos = Stars(Times%).Ypos - Stars(Times%).yincr
     CASE 3: Stars(Times%).XPos = Stars(Times%).XPos - Stars(Times%).Xincr
             Stars(Times%).Ypos = Stars(Times%).Ypos + Stars(Times%).yincr
     CASE 4: Stars(Times%).XPos = Stars(Times%).XPos + Stars(Times%).Xincr
             Stars(Times%).Ypos = Stars(Times%).Ypos + Stars(Times%).yincr
    END SELECT
    SELECT CASE Stars(Times%).XPos
     CASE IS <= 0, IS >= 320: GOSUB ReGenerate
    END SELECT
    SELECT CASE Stars(Times%).Ypos
     CASE IS <= 0, IS >= 200: GOSUB ReGenerate
    END SELECT
    SELECT CASE Stars(Times%).Active
     CASE Stars(Times%).Switcher: Stars(Times%).Size = Stars(Times%).Size + 1
                                  Stars(Times%).Active = 0
    END SELECT
    SELECT CASE Stars(Times%).Size
     CASE 5: GOSUB ReGenerate
    END SELECT
       Stars(Times%).Xincr = Stars(Times%).Xincr + Stars(Times%).Xincr * .08
       Stars(Times%).yincr = Stars(Times%).yincr + Stars(Times%).yincr * .08
   PSET (Stars(Times%).XPos, Stars(Times%).Ypos), 15
  NEXT Times%
RETURN


PlotStart:
        FOR T% = 1 TO 2
         Void% = RandNum(2)
         PlusMinus% = RandNum(10)
          SELECT CASE T%
           CASE 1: Acr% = Void%
                   SELECT CASE Void%
                     CASE 1: Stars(Times%).XPos = 160 + PlusMinus%
                     CASE 2: Stars(Times%).XPos = 160 - PlusMinus%
                   END SELECT
           CASE 2: Vert% = Void%
                   SELECT CASE Void%
                     CASE 1: Stars(Times%).Ypos = 100 + PlusMinus%
                     CASE 2: Stars(Times%).Ypos = 100 - PlusMinus%
                   END SELECT
          END SELECT
        NEXT
 SELECT CASE Vert%
  CASE 1: IF Acr% = 1 THEN Stars(Times%).Dir = 4 ELSE Stars(Times%).Dir = 3
  CASE 2: IF Acr% = 1 THEN Stars(Times%).Dir = 2 ELSE Stars(Times%).Dir = 1
 END SELECT
RETURN

ReGenerate:
       GOSUB PlotStart
       Stars(Times%).Ypos = RandNum(5) + 100
       Stars(Times%).Size = 0
       Stars(Times%).Active = 0
       Stars(Times%).Xincr = RND(1) * RandNum(1)
       Stars(Times%).yincr = RND(1) * RandNum(1)
       RETURN

FOR Times% = 1 TO SMax%
 GOSUB PlotStart
 Stars(Times%).Size = 0
 Stars(Times%).Xincr = RND(1) * RandNum(2)
 Stars(Times%).yincr = RND(1) * RandNum(2)
 Stars(Times%).Switcher = RandNum(27) + 20
NEXT Times%

REM $STATIC
SUB CloseUp
CLS
SCREEN 0
WIDTH 80
DEF SEG = &H40: POKE &H17, PEEK(&H17) AND 223  'turns off caps lock
DEF SEG = &H40: POKE &H17, PEEK(&H17) AND 171  'turns off num lock
DEF SEG = &H40: POKE &H17, PEEK(&H17) AND 275  'turns off scroll lock
SYSTEM
END SUB

FUNCTION GetDelay%
CLS
SCREEN 0
WIDTH 80
COLOR 13
PRINT "G R A V I T Y  by ";
COLOR 12
PRINT "Molnar \ Kucalaba Productions!"
COLOR 14
PRINT
PRINT "Please select the computer speed that best fits you : "
PRINT
COLOR 10
PRINT "1) 386"
PRINT "2) 486 dx 33"
PRINT "3) 486 dx 66"
PRINT "4) 586 (pentium) 75"
PRINT "5) Pentium 100"
PRINT "6) Pentium 133"
PRINT "7) Pentium 166"
PRINT "8) Something that's really fast"
INPUT Choice%
SELECT CASE Choice%
 CASE 1: GetDelay% = 2
 CASE 2: GetDelay% = 3
 CASE 3: GetDelay% = 4
 CASE 4: GetDelay% = 5
 CASE 5: GetDelay% = 6
 CASE 6: GetDelay% = 7
 CASE 7: GetDelay% = 8
 CASE 8: GetDelay% = 9
 CASE ELSE: GetDelay% = 4
END SELECT
END FUNCTION

DEFSNG A-Z
FUNCTION RandNum (u%)
RandNum = INT(RND * u%) + 1
END FUNCTION

