DECLARE SUB screensetup ()
DECLARE SUB makeworld ()
DECLARE SUB maketables ()

DECLARE SUB SETVECT (S AS INTEGER, O AS INTEGER, I AS INTEGER)
DECLARE SUB GETVECT (S AS INTEGER, O AS INTEGER, I AS INTEGER)
DECLARE SUB KEYBOARD.IN (OLDSEG AS INTEGER, OLDOFF AS INTEGER)
DECLARE SUB KEYBOARD.OUT (OLDSEG AS INTEGER, OLDOFF AS INTEGER)

'$STATIC

CONST NUM.KEYS = 10
CONST INDEX.UP = 0
CONST INDEX.DOWN = 1
CONST INDEX.LEFT = 2
CONST INDEX.RIGHT = 3
CONST INDEX.CTRL = 4
CONST INDEX.ALT = 5
CONST INDEX.SPACE = 6
CONST INDEX.ESC = 7
CONST INDEX.ENTER = 8
CONST INDEX.RSHIFT = 9

DIM SHARED KEY.TABLE(0 TO (NUM.KEYS - 1)) AS INTEGER
DIM SHARED RAWKEY AS INTEGER
DIM SHARED OLD.ISR.SEG AS INTEGER, OLD.ISR.OFF AS INTEGER

CALL KEYBOARD.IN(OLD.ISR.SEG, OLD.ISR.OFF)

DIM SHARED st%(0 TO 360)
DIM SHARED ct%(0 TO 360)
DIM SHARED a$(1 TO 10)
DIM SHARED grid(1 TO 12, 1 TO 12)
px% = 15: py% = 35: sa% = 0
PRINT "Please wait...";
RANDOMIZE TIMER
makeworld
maketables
screensetup
m% = 1
DO
  IF m% = 1 THEN
    IF P = 2 THEN PCOPY 2, 0 ELSE PCOPY 3, 0
    IF P = 2 THEN P = 3 ELSE P = 2
    m% = 0
  END IF
  FOR t% = sa% TO sa% + 59 STEP 1
    xb = st%(t% MOD 360) / 100              'get inc
    yb = ct%(t% MOD 360) / 100              'get inc
    bx = px%                                'decimal copy
    by = py%                                'decimal copy
    l% = 0                                  'reset length
    DO
      bx = bx + xb
      by = by + yb
      l% = l% + 1
      k% = grid(CINT(by / 10), CINT(bx / 10))
    LOOP UNTIL k% <> 0
    X% = (t% - sa%) * 5
    dd% = (1000 / l%)

    FOR U% = 0 TO 4
       LINE (X% + U%, 100 - dd%)-(X% + U%, 100 + dd%), k%
    NEXT U%

    LINE (X%, 100 - dd%)-(X% + 5, 100 - dd%), 0      'top lines
    LINE (X%, 100 + dd%)-(X% + 5, 100 + dd%), 0      'bottom lines
  NEXT t%
  PCOPY 0, 1
  RAWKEY = 0: WHILE RAWKEY = 0: WEND
  IF KEY.TABLE(INDEX.RIGHT) THEN ' [LEFT]
    sa% = sa% + 5
    m% = 1
  END IF
  IF KEY.TABLE(INDEX.LEFT) THEN ' [RIGHT]
    sa% = (sa% + 355) MOD 360
    m% = 1
  END IF
  IF KEY.TABLE(INDEX.ESC) THEN ' [ESC]
    quit = 1
  END IF
  IF KEY.TABLE(INDEX.UP) THEN ' [UP]
    Oldpx% = px%: Oldpy% = py% ' Save where you are
    px% = px% + (st%((sa% + 30) MOD 360) / 30)
    py% = py% + (ct%((sa% + 30) MOD 360) / 30)
    IF grid(CINT(py% / 10), CINT(px% / 10)) > 0 THEN 'Walking thru walls?
      SOUND 80, 1
      px% = Oldpx% ' Forget it!  Don't move
      py% = Oldpy%
    ELSE
      m% = 1
    END IF
  END IF
    
  IF KEY.TABLE(INDEX.DOWN) THEN '[DOWN]
    Oldpx% = px%: Oldpy% = py% ' Save where you are
    px% = px% - (st%((sa% + 30) MOD 360) / 30)
    py% = py% - (ct%((sa% + 30) MOD 360) / 30)
    IF grid(CINT(py% / 10), CINT(px% / 10)) > 0 THEN 'Walking thru walls?
      SOUND 80, 1
      px% = Oldpx% ' Forget it!  Don't move
      py% = Oldpy%
    ELSE
      m% = 1
    END IF
  END IF
LOOP UNTIL quit > 0
SCREEN 0
WIDTH 80, 25

CALL KEYBOARD.OUT(OLD.ISR.SEG, OLD.ISR.OFF)

SYSTEM

' Level data (this way you can have walls colored 10, 11, etc.)
' 12x12
DATA  1, 9, 1, 9, 1, 9, 1, 9, 1, 9, 1, 9
DATA  9, 0, 4, 0, 0, 0, 0, 0, 0, 5, 0, 1
DATA  1, 0,12, 0, 0, 0, 0, 0, 0,13, 0, 9
DATA  9, 0, 4, 0, 0, 0, 0, 0, 0, 5, 0, 1
DATA  1, 0,12, 0, 0, 0, 0, 0, 0,13, 0, 9
DATA  9, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 1
DATA  1, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 9
DATA  9, 0,12, 0, 0, 0, 0, 0, 0, 0, 0, 1
DATA  1, 0, 4, 0, 0, 0, 0, 0, 3,11, 0, 9
DATA  9, 0,12, 0, 0, 0, 0, 0,11, 3, 0, 1
DATA  1, 0, 4, 0, 0, 0, 0, 0, 0, 0, 0, 9
DATA  9, 1, 9, 1, 9, 1, 9, 1, 9, 1, 9, 1

' Old level.  If you want it, come and get it.
'  1, 9, 1, 9, 1, 9, 1, 9, 1, 9
'  9, 0, 0, 0, 0, 0, 0, 0, 0, 1
'  1, 0, 0, 0, 0, 0, 0, 4, 0, 9
'  9, 0, 1, 0, 0, 0, 5, 0, 0, 1
'  1, 0, 2, 0, 0, 4, 0, 0, 0, 9
'  9, 0, 3, 0, 0, 0, 0, 0, 0, 1
'  1, 0, 0, 0, 0, 7, 8, 0, 0, 9
'  9, 0, 5, 0, 0, 8, 7, 0, 0, 1
'  1, 0, 6, 0, 0, 0, 0, 0, 0, 9
'  9, 1, 9, 1, 9, 1, 9, 1, 9, 1

SUB GETVECT (S AS INTEGER, O AS INTEGER, I AS INTEGER)

    'GETVECT RETURNS THE ADDRESS OF A FUNCTION POINTED TO IN THE
    'INTERRUPT VECTOR TABLE (STARTS AT 0000:0000H)

    STATIC ASM AS STRING 'THE CODE FOR GETVECT

    STATIC INI AS INTEGER 'USED TO DETECT WHETHER GETVECT HAS PREVIOUSLY
                          'BEEN CALLED
    IF INI = 0 THEN
        
        'CREATE ML FUNCTION IF NOT ALREADY CREATED

        ASM = ASM + CHR$(&H55)                          'PUSH    BP
        ASM = ASM + CHR$(&H89) + CHR$(&HE5)             'MOV     BP,SP
        ASM = ASM + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6) 'MOV     BX,[BP+06]
        ASM = ASM + CHR$(&H8A) + CHR$(&H7)              'MOV     AL,[BX]
        ASM = ASM + CHR$(&HB4) + CHR$(&H35)             'MOV     AH,35
        ASM = ASM + CHR$(&HCD) + CHR$(&H21)             'INT     21
        ASM = ASM + CHR$(&H53)                          'PUSH    BX
        ASM = ASM + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HA) 'MOV     BX,[BP+0A]
        ASM = ASM + CHR$(&H8C) + CHR$(&H7)              'MOV     [BX],ES
        ASM = ASM + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8) 'MOV     BX,[BP+08]
        ASM = ASM + CHR$(&H58)                          'POP     AX
        ASM = ASM + CHR$(&H89) + CHR$(&H7)              'MOV     [BX],AX
        ASM = ASM + CHR$(&H5D)                          'POP     BP
        ASM = ASM + CHR$(&HCA) + CHR$(&H6) + CHR$(&H0)  'RETF    0006
        INI = 1 'FLAG CREATION
    END IF

    DEF SEG = VARSEG(ASM)
    CALL ABSOLUTE(S, O, I, SADD(ASM)) 'RUN FUNCTION
END SUB

SUB KEYBOARD.IN (OLDSEG AS INTEGER, OLDOFF AS INTEGER)
    DIM RSGL AS INTEGER, RSGH AS INTEGER 'SEGMENT OF RAWKEY
    DIM ROFL AS INTEGER, ROFH AS INTEGER 'OFFSET OF RAWKEY

    DIM KSGL AS INTEGER, KSGH AS INTEGER 'SEGMENT OF KEY.TABLE
    DIM KOFL AS INTEGER, KOFH AS INTEGER 'OFFSET OF KEY.TABLE
   
    DIM BYTE AS STRING * 1 'USED TO ACTIVATE IRQ 1 IN PIC

    STATIC ASM AS STRING 'HOLDS ISR

    RSGL = VARSEG(RAWKEY) AND &HFF 'LOAD LOW "BYTE" SEGMENT
    RSGH = INT(VARSEG(RAWKEY) / 256) AND &HFF 'LOAD HIGH "BYTE" SEGMENT

    ROFL = VARPTR(RAWKEY) AND &HFF 'LOAD LOW "BYTE" OFFSET
    ROFH = INT(VARPTR(RAWKEY) / 256) AND &HFF 'LOAD HIGH "BYTE" OFFSET
    
    KSGL = VARSEG(KEY.TABLE(0)) AND &HFF 'LOAD LOW "BYTE" SEGMENT
    KSGH = INT(VARSEG(KEY.TABLE(0)) / 256) AND &HFF 'LOAD HIGH "BYTE" SEGMENT

    KOFL = VARPTR(KEY.TABLE(0)) AND &HFF 'LOAD LOW "BYTE" OFFSET
    KOFH = INT(VARPTR(KEY.TABLE(0)) / 256) AND &HFF 'LOAD HIGH "BYTE" OFFSET

    'THIS IS THE ISR.  IT READS A SCANCODE FROM THE KEYBOARD BUFFER
    'AND RESETS IT.  THE BEST PART IS, BIOS CAN'T TOUCH IT!

    ASM = ""
    ASM = ASM + CHR$(&H52)                          'PUSH DX
    ASM = ASM + CHR$(&H51)                          'PUSH CX
    ASM = ASM + CHR$(&H53)                          'PUSH BX
    ASM = ASM + CHR$(&H50)                          'PUSH AX
    ASM = ASM + CHR$(&H6)                           'PUSH ES
    ASM = ASM + CHR$(&H57)                          'PUSH DI
    ASM = ASM + CHR$(&H1E)                          'PUSH DS
    ASM = ASM + CHR$(&H56)                          'PUSH SI
    ASM = ASM + CHR$(&HFB)                          'STI
    ASM = ASM + CHR$(&HBA) + CHR$(&H60) + CHR$(&H0) 'MOV DX,0060
    ASM = ASM + CHR$(&HEC)                          'IN AL,DX
    ASM = ASM + CHR$(&H30) + CHR$(&HE4)             'XOR AH,AH
    ASM = ASM + CHR$(&HBA) + CHR$(RSGL) + CHR$(RSGH)'MOV DX,SEG RAWKEY
    ASM = ASM + CHR$(&H8E) + CHR$(&HDA)             'MOV DS,DX
    ASM = ASM + CHR$(&HBE) + CHR$(ROFL) + CHR$(ROFH)'MOV SI,OFFSET RAWKEY
    ASM = ASM + CHR$(&H88) + CHR$(&H4)              'MOV [SI],AL
    ASM = ASM + CHR$(&H50)                          'PUSH AX
    ASM = ASM + CHR$(&HBA) + CHR$(&H61) + CHR$(&H0) 'MOV DX,0061
    ASM = ASM + CHR$(&HEC)                          'IN AL,DX
    ASM = ASM + CHR$(&HC) + CHR$(&H82)              'OR AL,82
    ASM = ASM + CHR$(&HEE)                          'OUT DX,AL
    ASM = ASM + CHR$(&H24) + CHR$(&H7F)             'AND AL,7F
    ASM = ASM + CHR$(&HEE)                          'OUT DX,AL
    ASM = ASM + CHR$(&HB0) + CHR$(&H20)             'MOV AL,20
    ASM = ASM + CHR$(&HBA) + CHR$(&H20) + CHR$(&H0) 'MOV DX,0020
    ASM = ASM + CHR$(&HEE)                          'OUT DX,AL
    ASM = ASM + CHR$(&HBA) + CHR$(KSGL) + CHR$(KSGH)'MOV DX,SEG KEY.TABLE
    ASM = ASM + CHR$(&H8E) + CHR$(&HDA)             'MOV DS,DX
    ASM = ASM + CHR$(&HBE) + CHR$(KOFL) + CHR$(KOFH)'MOV SI,OFFSET KEY.TABLE
    ASM = ASM + CHR$(&H58)                          'POP AX
    ASM = ASM + CHR$(&HBB) + CHR$(&H1) + CHR$(&H0)  'MOV BX,0001--MAKE
    ASM = ASM + CHR$(&HB4) + CHR$(&H48)             'MOV AH,48--UP
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H0) 'MOV [SI+00],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H50)             'MOV AH,50--DOWN
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H2) 'MOV [SI+02],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H4B)             'MOV AH,4B--LEFT
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H4) 'MOV [SI+04],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H4D)             'MOV AH,4D--RIGHT
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H6) 'MOV [SI+06],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H1D)             'MOV AH,1D--CTRL
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H8) 'MOV [SI+08],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H38)             'MOV AH,38--ALT
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&HA) 'MOV [SI+0A],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H39)             'MOV AH,39--SPACE
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&HC) 'MOV [SI+0C],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H1)              'MOV AH,01--ESC
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&HE) 'MOV [SI+0E],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H1C)             'MOV AH,1C--ENTER
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H10)'MOV [SI+10],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H36)             'MOV AH,36--RSHIFT
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H12)'MOV [SI+12],BX

    ASM = ASM + CHR$(&HBB) + CHR$(&H0) + CHR$(&H0)  'MOV BX,0000--BREAK
    ASM = ASM + CHR$(&HB4) + CHR$(&HC8)             'MOV AH,C8--UP
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H0) 'MOV [SI+00],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&HD0)             'MOV AH,D0--DOWN
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H2) 'MOV [SI+02],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&HCB)             'MOV AH,CB--LEFT
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H4) 'MOV [SI+04],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&HCD)             'MOV AH,CD--RIGHT
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H6) 'MOV [SI+06],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H9D)             'MOV AH,9D--CTRL
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H8) 'MOV [SI+08],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&HB8)             'MOV AH,B8--ALT
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&HA) 'MOV [SI+0A],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&HB9)             'MOV AH,B9--SPACE
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&HC) 'MOV [SI+0C],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H81)             'MOV AH,81--ESC
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ 
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&HE) 'MOV [SI+0E],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&H9C)             'MOV AH,9C--ENTER
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H10)'MOV [SI+10],BX
    ASM = ASM + CHR$(&HB4) + CHR$(&HB6)             'MOV AH,B6--RSHIFT
    ASM = ASM + CHR$(&H38) + CHR$(&HC4)             'CMP AH,AL
    ASM = ASM + CHR$(&H75) + CHR$(&H3)              'JNZ
    ASM = ASM + CHR$(&H89) + CHR$(&H5C) + CHR$(&H12)'MOV [SI+12],BX

    ASM = ASM + CHR$(&HFA)                          'CLI
    ASM = ASM + CHR$(&H5E)                          'POP SI
    ASM = ASM + CHR$(&H1F)                          'POP DS
    ASM = ASM + CHR$(&H5F)                          'POP DI
    ASM = ASM + CHR$(&H7)                           'POP ES
    ASM = ASM + CHR$(&H58)                          'POP AX
    ASM = ASM + CHR$(&H5B)                          'POP BX
    ASM = ASM + CHR$(&H59)                          'POP CX
    ASM = ASM + CHR$(&H5A)                          'POP DX
    ASM = ASM + CHR$(&HCF)                          'IRET

    BYTE = CHR$(INP(&H21)) 'LOAD IRQ ENABLE REGISTER IN PIC

    OUT &H21, (ASC(BYTE) AND (255 XOR 2)) 'CLEAR BIT 2 (IRQ 1)

    CALL GETVECT(OLDSEG, OLDOFF, &H9) 'LOAD OLD ISR
    CALL SETVECT(VARSEG(ASM), SADD(ASM), &H9) 'STORE NEW ISR
END SUB

SUB KEYBOARD.OUT (OLDSEG AS INTEGER, OLDOFF AS INTEGER)
    CALL SETVECT(OLDSEG, OLDOFF, &H9) 'RESTORE OLD ISR
END SUB

SUB maketables

' Peters boring _yawn_ table creation
FOR tmp1% = 0 TO 360
  st%(tmp1%) = SIN(tmp1% * .0174) * 100
  'IF tmp1% MOD 100 = 0 THEN PRINT ; ".";
  'NEXT tmp1%
  'FOR tmp1% = 0 TO 360
  ct%(tmp1%) = COS(tmp1% * .0174) * 100
  'IF tmp1% MOD 100 = 0 THEN PRINT ; ".";
NEXT tmp1%

END SUB

SUB makeworld

FOR j = 1 TO 12
  FOR I = 1 TO 12
    READ grid(I, j)
  NEXT I
NEXT j

END SUB

SUB screensetup

SCREEN 7, , 0, 1

LINE (0, 0)-(300, 99), 3, BF
LINE (0, 100)-(300, 200), 8, BF
PCOPY 0, 2
PCOPY 0, 3

END SUB

SUB SETVECT (S AS INTEGER, O AS INTEGER, I AS INTEGER)

    'SETVECT CHANGES THE ADDRESSES IN THE INTERRUPT VECTOR TABLE
    'TO POINT TO NEW FUNCTIONS

    STATIC ASM AS STRING 'HOLDS THE SETVECT FUNCTION
    STATIC INI AS INTEGER 'USED TO TEST WHETHER OR NOT FUNCTION HAS PREVOUSLY
                          'BEEN CALLED
    IF INI = 0 THEN

        'CREATE FUNCTION IF NOT ALREADY CREATED

        ASM = ""
        ASM = ASM + CHR$(&H55)                          'PUSH BP
        ASM = ASM + CHR$(&H89) + CHR$(&HE5)             'MOV BP,SP
        ASM = ASM + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H8) 'MOV BX,[BP+08]
        ASM = ASM + CHR$(&H8B) + CHR$(&H17)             'MOV DX,[BX]
        ASM = ASM + CHR$(&H8B) + CHR$(&H5E) + CHR$(&H6) 'MOV BX,[BP+06]
        ASM = ASM + CHR$(&H8A) + CHR$(&H7)              'MOV AL,[BX]
        ASM = ASM + CHR$(&H8B) + CHR$(&H5E) + CHR$(&HA) 'MOV BX,[BP+0A]
        ASM = ASM + CHR$(&H1E)                          'PUSH DS
        ASM = ASM + CHR$(&H8E) + CHR$(&H1F)             'MOV DS,[BX]
        ASM = ASM + CHR$(&HB4) + CHR$(&H25)             'MOV AH,25
        ASM = ASM + CHR$(&HCD) + CHR$(&H21)             'INT 21
        ASM = ASM + CHR$(&H1F)                          'POP DS
        ASM = ASM + CHR$(&H5D)                          'POP BP
        ASM = ASM + CHR$(&HCA) + CHR$(&H6) + CHR$(&H0)  'RETF 0006
        INI = 1 'FLAG CREATION
    END IF
    DEF SEG = VARSEG(ASM)
    CALL ABSOLUTE(S, O, I, SADD(ASM)) 'RUN SETVECT
END SUB

