DECLARE SUB GridToggle ()
DECLARE SUB DeleteColourSelector ()
DECLARE SUB Pick ()
DECLARE SUB DrawPreviewSquare ()
DECLARE SUB UpdatePreview ()
DECLARE SUB New ()
DECLARE SUB Quit ()
DECLARE SUB Load ()
DECLARE SUB Save ()
DECLARE SUB DrawCell ()
DECLARE SUB DrawColourSelector ()
DECLARE SUB DrawColourGrid ()
DECLARE SUB ReadKeyboard ()
DECLARE SUB DrawSelector ()
DECLARE SUB DrawGrid ()

'*Sprite Editor*
'By Thomas Houghton
'10/1/97

COMMON SHARED GridX, GridY, SelectorX, SelectorY, ConstantDraw
COMMON SHARED CellHeight, CellWidth, GridColour, SelectorColour
COMMON SHARED KeyPress$, SelectorDirection$, SelectedColour
COMMON SHARED PreviewX, PreviewY, OldGridColour, CellColumns, CellRows

GridColour = 31
SelectorColour = 40
CellColumns = 17
CellRows = 15
CellHeight = INT(159 / CellRows)
CellWidth = INT(210 / CellColumns)
IF CellWidth < CellHeight THEN  'make cells square
        CellHeight = CellWidth
ELSE
        CellWidth = CellHeight
END IF
GridX = 0
GridY = 40
SelectorX = 1
SelectorY = 1
SelectedColour = 0
PreviewX = INT(GridX + (CellWidth * CellColumns) + ((320 - (GridX + (CellWidth * CellColumns))) / 2) - ((CellColumns) / 2))
PreviewY = GridY

DIM SHARED CellColour(100, 100)

SCREEN 13
CLS

CALL DrawGrid
CALL DrawSelector
CALL DrawColourGrid
CALL DrawColourSelector
CALL DrawPreviewSquare

DO
CALL ReadKeyboard

LOOP

SUB DeleteColourSelector
'delete old selector
LINE (SelectedColour + 1, GridY - 17)-(SelectedColour + 1, GridY - 20), 0
LINE (SelectedColour + 1, GridY - 7)-(SelectedColour + 1, GridY - 4), 0

END SUB

SUB DrawCell
LINE (GridX - 1 + (SelectorX * CellWidth), GridY - 1 + (SelectorY * CellHeight))-(GridX - CellWidth + 1 + (SelectorX * CellWidth), GridY - CellHeight + 1 + (SelectorY * CellHeight)), SelectedColour, BF

CellColour(SelectorX, SelectorY) = SelectedColour

'update preview
PSET (PreviewX + SelectorX, PreviewY + SelectorY), SelectedColour

END SUB

SUB DrawColourGrid
LINE (0, GridY - 16)-(249, GridY - 8), GridColour, B
FOR l = 0 TO 247
        LINE (l + 1, GridY - 15)-(l + 1, GridY - 9), l
NEXT l

END SUB

SUB DrawColourSelector
IF GridColour = 0 THEN c = OldGridColour ELSE c = GridColour  'make draw when grid off

IF KeyPress$ = "c" THEN SelectedColour = SelectedColour + 1
IF SelectedColour = 248 THEN SelectedColour = 0
IF KeyPress$ = "x" THEN SelectedColour = SelectedColour - 1
IF SelectedColour = -1 THEN SelectedColour = 247

'draw new selector
LINE (SelectedColour + 1, GridY - 17)-(SelectedColour + 1, GridY - 20), c
LINE (SelectedColour + 1, GridY - 7)-(SelectedColour + 1, GridY - 4), c

'draw selected-colour box
LINE (252, GridY - 16)-(319, GridY - 8), c, B
LINE (253, GridY - 15)-(318, GridY - 9), SelectedColour, BF

END SUB

SUB DrawGrid
FOR r = 0 TO CellRows
        LINE (GridX, GridY + (r * CellHeight))-(GridX + (CellColumns * CellWidth), GridY + (r * CellHeight)), GridColour  'horizontal
NEXT r

FOR c = 0 TO CellColumns
        LINE (GridX + (c * CellWidth), GridY)-(GridX + (c * CellWidth), GridY + (CellRows * CellHeight)), GridColour  'vertical
NEXT c

END SUB

SUB DrawPreviewSquare
LINE (PreviewX, PreviewY)-(PreviewX + CellColumns + 1, PreviewY + CellRows + 1), GridColour, B

END SUB

SUB DrawSelector
'delete old selector
LINE ((SelectorX * CellWidth) + GridX, (SelectorY * CellHeight) + GridY)-((SelectorX * CellWidth) + GridX - CellWidth, (SelectorY * CellHeight) + GridY - CellHeight), GridColour, B

'move selector
IF SelectorDirection$ = "up" AND SelectorY > 1 THEN
        SelectorY = SelectorY - 1
ELSEIF SelectorDirection$ = "down" AND SelectorY < CellRows THEN
        SelectorY = SelectorY + 1
ELSEIF SelectorDirection$ = "left" AND SelectorX > 1 THEN
        SelectorX = SelectorX - 1
ELSEIF SelectorDirection$ = "right" AND SelectorX < CellColumns THEN
        SelectorX = SelectorX + 1
END IF

SelectorDirection$ = ""

'draw new selector
LINE ((SelectorX * CellWidth) + GridX, (SelectorY * CellHeight) + GridY)-((SelectorX * CellWidth) + GridX - CellWidth, (SelectorY * CellHeight) + GridY - CellHeight), SelectorColour, B

'paint if constant-draw is on
IF ConstantDraw = 1 THEN CALL DrawCell

'print co-ords
LOCATE 23, 28
PRINT "X="; SelectorX; " Y="; SelectorY

END SUB

SUB GridToggle
IF GridColour = 0 THEN  'turn grid on
        GridColour = OldGridColour
ELSE  'turn grid off
        OldGridColour = GridColour
        GridColour = 0
END IF

CALL DrawGrid
CALL DrawSelector

END SUB

SUB Load
LOCATE 1, 1
INPUT "Path + Filename"; Filename$

IF Filename$ <> "" THEN  'do only if filename entered

CALL DeleteColourSelector

'remove preview
LINE (PreviewX, PreviewY)-(PreviewX + CellColumns + 1, PreviewY + CellRows + 1), 0, BF

'remove grid and picture
LINE (GridX, GridY)-(GridX + (CellWidth * CellColumns), GridY + (CellHeight * CellRows)), 0, BF

OPEN Filename$ FOR INPUT AS #1
        FOR d = 1 TO 2  'get dimensions
                IF d = 1 THEN INPUT #1, CellColumns
                IF d = 2 THEN INPUT #1, CellRows
        NEXT d
       
        'resize screen
        CellHeight = INT(159 / CellRows)
        CellWidth = INT(210 / CellColumns)
        IF CellWidth < CellHeight THEN  'make cells square
                CellHeight = CellWidth
        ELSE
                CellWidth = CellHeight
        END IF
        PreviewX = INT(GridX + (CellWidth * CellColumns) + ((320 - (GridX + (CellWidth * CellColumns))) / 2) - ((CellColumns) / 2))
        PreviewY = GridY
        IF GridColour = 0 THEN GridColour = OldGridColour
        CALL DrawGrid
        CALL DrawPreviewSquare
       
        FOR y = 1 TO CellRows  'load picture
                FOR x = 1 TO CellColumns
                        INPUT #1, SelectedColour
                        SelectorX = x
                        SelectorY = y
                        CALL DrawCell
                NEXT x
        NEXT y
CLOSE #1

'finish screen redraw
ConstantDraw = 0
SelectorX = 1
SelectorY = 1
SelectedColour = 0
CALL DrawSelector
CALL DrawColourSelector

ELSE
'if only [enter] pressed then don't do anything
END IF

'delete text at top of screen
LOCATE 1, 1: PRINT "                                        "
LOCATE 2, 1: PRINT "                                        "

END SUB

SUB New
LOCATE 1, 1: PRINT "Are you sure?"
DO
        KeyPress$ = INKEY$
LOOP UNTIL KeyPress$ <> ""
       
IF KeyPress$ = "y" THEN
        'remove preview
        LINE (PreviewX, PreviewY)-(PreviewX + CellColumns + 1, PreviewY + CellRows + 1), 0, BF

        'remove grid and picture
        LINE (GridX, GridY)-(GridX + (CellWidth * CellColumns), GridY + (CellHeight * CellRows)), 0, BF
              
        CALL DeleteColourSelector

        'clear cells in memory
        FOR y = 1 TO CellRows
                FOR x = 1 TO CellColumns
                        CellColour(x, y) = 0
                NEXT x
        NEXT y

        LOCATE 1, 1: PRINT "                                        "
        LOCATE 1, 1: INPUT "X Dimensions"; CellColumns
        LOCATE 2, 1: INPUT "Y Dimensions"; CellRows
      
        'resize and redraw screen
        CellHeight = INT(159 / CellRows)
        CellWidth = INT(210 / CellColumns)
        IF CellWidth < CellHeight THEN
                CellHeight = CellWidth
        ELSE
                CellWidth = CellHeight
        END IF
        PreviewX = INT(GridX + (CellWidth * CellColumns) + ((320 - (GridX + (CellWidth * CellColumns))) / 2) - ((CellColumns) / 2))
        PreviewY = GridY
        IF GridColour = 0 THEN GridColour = OldGridColour
        CALL DrawGrid
        CALL DrawPreviewSquare
       
        'delete text at top of screen
        LOCATE 1, 1: PRINT "                                        "
        LOCATE 2, 1: PRINT "                                        "
               
        'finish screen redraw
        ConstantDraw = 0
        SelectorX = 1
        SelectorY = 1
        CALL DrawSelector
        SelectedColour = 0
        CALL DrawColourSelector
ELSE

END IF

'delete text at top of screen
LOCATE 1, 1: PRINT "                                        "
LOCATE 2, 1: PRINT "                                        "

END SUB

SUB Pick
CALL DeleteColourSelector
SelectedColour = CellColour(SelectorX, SelectorY)
CALL DrawColourSelector

END SUB

SUB Quit
LOCATE 1, 1
PRINT "Are you sure?"
DO
        KeyPress$ = INKEY$
LOOP UNTIL KeyPress$ <> ""
        IF KeyPress$ = "y" THEN
                END
        ELSE
                'delete text at top of screen
                LOCATE 1, 1: PRINT "                                        "
                LOCATE 2, 1: PRINT "                                        "
        END IF

END SUB

SUB ReadKeyboard
KeyPress$ = INKEY$
SELECT CASE KeyPress$
        CASE "8"  'up
                SelectorDirection$ = "up"
                CALL DrawSelector
        CASE "2"  'down
                SelectorDirection$ = "down"
                CALL DrawSelector
        CASE "4"  'left
                SelectorDirection$ = "left"
                CALL DrawSelector
        CASE "6"  'right
                SelectorDirection$ = "right"
                CALL DrawSelector
        CASE "c", "x"  'cycle colour
                CALL DeleteColourSelector
                CALL DrawColourSelector
        CASE " "  'draw
                CALL DrawCell
        CASE "d"  'constant-draw mode
                IF ConstantDraw = 0 THEN
                        ConstantDraw = 1
                ELSE
                        ConstantDraw = 0
                END IF
                CALL DrawCell
        CASE "s"  'save
                CALL Save
        CASE "l"  'load
                CALL Load
        CASE "n"  'new
                CALL New
        CASE "p"  'pick colour
                CALL Pick
        CASE "g"  'grid on/off
                CALL GridToggle
        CASE CHR$(27), "q" 'exit on ESC or q
                CALL Quit
        CASE ELSE
END SELECT

END SUB

SUB Save
LOCATE 1, 1
INPUT "Path + Filename"; Filename$

IF Filename$ <> "" THEN  'only do if filename is entered

OPEN Filename$ FOR OUTPUT AS #1
        FOR d = 1 TO 2  'save dimensions
                IF d = 1 THEN PRINT #1, CellColumns
                IF d = 2 THEN PRINT #1, CellRows
        NEXT d
       
        FOR y = 1 TO CellRows  'save picture
                FOR x = 1 TO CellColumns
                        PRINT #1, CellColour(x, y)
                NEXT x
        NEXT y
CLOSE #1

ELSE
'if only [enter] pressed then don't do anything
END IF

'delete text at top of screen
LOCATE 1, 1: PRINT "                                        "
LOCATE 2, 1: PRINT "                                        "

END SUB

